"
 COPYRIGHT (c) 1996-2011 by Claus Gittinger
 COPYRIGHT (c) 2010-2011 by Jan Vrany, Jan Kurs and Marcel Hlopko
                            SWING Research Group, Czech Technical University in Prague

 Parts of the code written by Claus Gittinger are under following
 license:

 This software is furnished under a license and may be used
 only in accordance with the terms of that license and with the
 inclusion of the above copyright notice.   This software may not
 be provided or otherwise made available to, or used by, any
 other person.  No title to or ownership of the software is
 hereby transferred.

 Parts of the code written at SWING Reasearch Group [1] are MIT licensed:

 Permission is hereby granted, free of charge, to any person
 obtaining a copy of this software and associated documentation
 files (the 'Software'), to deal in the Software without
 restriction, including without limitation the rights to use,
 copy, modify, merge, publish, distribute, sublicense, and/or sell
 copies of the Software, and to permit persons to whom the
 Software is furnished to do so, subject to the following
 conditions:

 The above copyright notice and this permission notice shall be
 included in all copies or substantial portions of the Software.

 THE SOFTWARE IS PROVIDED 'AS IS', WITHOUT WARRANTY OF ANY KIND,
 EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES
 OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND
 NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT
 HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY,
 WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
 FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR
 OTHER DEALINGS IN THE SOFTWARE.

 [1] Code written at SWING Research Group contain a signature
     of one of the above copright owners.
"
"{ Package: 'stx:libjava' }"

TestCase subclass:#LookupTests
	instanceVariableNames:''
	classVariableNames:''
	poolDictionaries:''
	category:'Languages-Java-Lookup-Tests'
!

!LookupTests class methodsFor:'documentation'!

copyright
"
 COPYRIGHT (c) 1996-2011 by Claus Gittinger
 COPYRIGHT (c) 2010-2011 by Jan Vrany, Jan Kurs and Marcel Hlopko
                            SWING Research Group, Czech Technical University in Prague

 Parts of the code written by Claus Gittinger are under following
 license:

 This software is furnished under a license and may be used
 only in accordance with the terms of that license and with the
 inclusion of the above copyright notice.   This software may not
 be provided or otherwise made available to, or used by, any
 other person.  No title to or ownership of the software is
 hereby transferred.

 Parts of the code written at SWING Reasearch Group [1] are MIT licensed:

 Permission is hereby granted, free of charge, to any person
 obtaining a copy of this software and associated documentation
 files (the 'Software'), to deal in the Software without
 restriction, including without limitation the rights to use,
 copy, modify, merge, publish, distribute, sublicense, and/or sell
 copies of the Software, and to permit persons to whom the
 Software is furnished to do so, subject to the following
 conditions:

 The above copyright notice and this permission notice shall be
 included in all copies or substantial portions of the Software.

 THE SOFTWARE IS PROVIDED 'AS IS', WITHOUT WARRANTY OF ANY KIND,
 EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES
 OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND
 NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT
 HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY,
 WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
 FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR
 OTHER DEALINGS IN THE SOFTWARE.

 [1] Code written at SWING Research Group contain a signature
     of one of the above copright owners.

"
! !

!LookupTests methodsFor:'running'!

testFindBestMatchOfIn
    | sm selectors lo match |
    lo := JavaLookup instance.
    sm := lo descriptorForSmalltalkSelector: #main arguments: nil.
    
    selectors := #(#'main()V' #'main(l)l') collect: [:s | lo descriptorForJavaSelector: s ].
    match := JavaLookup instance findBestMatchOf: sm in: selectors.
    self assert: match name = 'main'.
    self assert: match argSize = 0.

    "Created: / 29-08-2011 / 23:28:02 / Jan Kurs <kursjan@fit.cvut.cz>"
!

testFindBestMatchOfIn1
    | sm selectors lo match |
    lo := JavaLookup instance.
    sm := lo descriptorForSmalltalkSelector: #main: arguments: #(1).
    
    selectors := #(#'main()V' #'main(l)l') collect: [:s | lo descriptorForJavaSelector: s ].
    match := JavaLookup instance findBestMatchOf: sm in: selectors.
    self assert: match name = 'main'.
    self assert: match argSize = 1.

    "Created: / 30-08-2011 / 21:18:25 / Jan Kurs <kursjan@fit.cvut.cz>"
!

testFindBestMatchOfIn2
    |sm selectors lo match|

    lo := JavaLookup instance.
    sm := lo descriptorForSmalltalkSelector:#main:and: arguments:#( 1 ).
    selectors := #( #'main()V' #'main(l)l' ) 
                collect:[:s | lo descriptorForJavaSelector:s ].
    match := JavaLookup instance findBestMatchOf:sm in:selectors.
    self assert: match isNil.

    "Created: / 30-08-2011 / 21:18:53 / Jan Kurs <kursjan@fit.cvut.cz>"
!

testFindBestMatchOfIn3
    |sm selectors lo match|

    lo := JavaLookup instance.
    sm := lo descriptorForSmalltalkSelector:#main:and: arguments:#( 1 2 ).
    selectors := #( #'main()V' #'main(l)l' #'main(lLjava/lang/Object;)l' ) 
                collect:[:s | lo descriptorForJavaSelector:s ].
    match := JavaLookup instance findBestMatchOf:sm in:selectors.
    self assert:match name = 'main'.
    self assert:match argSize = 2.

    "Created: / 30-08-2011 / 21:19:23 / Jan Kurs <kursjan@fit.cvut.cz>"
!

testFindBestMatchOfIn4
    |sm selectors lo match|

    lo := JavaLookup instance.
    sm := lo descriptorForSmalltalkSelector:#foo: arguments:#( 1 ).
    selectors := #( #'foo(Ljava/lang/String;)V' #'foo(Ljava/lang/Integer;)V' ) 
                collect:[:s | lo descriptorForJavaSelector:s ].
    match := JavaLookup instance findBestMatchOf:sm in:selectors.
    self assert:match selector = #'foo(Ljava/lang/Integer;)V'.

    "Created: / 05-09-2011 / 21:42:19 / Jan Kurs <kursjan@fit.cvut.cz>"
!

testFindBestMatchOfIn5
    |sm selectors lo match|

    lo := JavaLookup instance.
    sm := lo descriptorForSmalltalkSelector:#foo: arguments:#( 'Hi' ).
    selectors := #( #'foo(Ljava/lang/String;)V' #'foo(Ljava/lang/Integer;)V' ) 
                collect:[:s | lo descriptorForJavaSelector:s ].
    match := JavaLookup instance findBestMatchOf:sm in:selectors.
    self assert:match selector = #'foo(Ljava/lang/String;)V'.

    "Created: / 05-09-2011 / 22:11:58 / Jan Kurs <kursjan@fit.cvut.cz>"
!

testFindBestMatchOfIn6
    |sm selectors lo match|

    lo := JavaLookup instance.
    sm := lo descriptorForSmalltalkSelector:#getSize: arguments: (Array with: (Set new)).
    selectors := #( #'getSize(Ljava/util/Set;)I' #'getSize(Ljava/lang/Integer;Ljava/lang/Integer;)V' ) 
                collect:[:s | lo descriptorForJavaSelector:s ].
    match := JavaLookup instance findBestMatchOf:sm in:selectors.
    self assert:match selector = #'getSize(Ljava/util/Set;)I'.

    "Created: / 25-09-2011 / 16:44:24 / Jan Kurs <kursjan@fit.cvut.cz>"
!

testFindBestMatchOfInException
    |sm lo match|

    lo := JavaLookup instance.
    sm := lo descriptorForSmalltalkSelector:#main:and: arguments:#( 1 ).
    match := JavaLookup instance findBestMatchOf:sm in:#().
    self assert: match isNil.

    "Created: / 30-08-2011 / 22:07:09 / Jan Kurs <kursjan@fit.cvut.cz>"
!

testLookup
    |lo o match|

    lo := JavaLookup instance.
    o := (Java classForName:('java.lang.Object')) new.
    match := lo 
                lookupMethodForSelector:#toString
                directedTo:o class
                for:o
                withArguments:nil
                from:self.
    self assert:match selector = #'toString()Ljava/lang/String;'.

    "Created: / 30-08-2011 / 21:23:56 / Jan Kurs <kursjan@fit.cvut.cz>"
!

testLookup2
    |lo o match|

    lo := JavaLookup instance.
    o := (Java classForName:('java.lang.Object')) new.
    match := lo 
                lookupMethodForSelector:#hashCode
                directedTo:o class
                for:o
                withArguments:nil
                from:self.
    self assert:match selector = #'hashCode()I'.

    "Created: / 30-08-2011 / 21:54:53 / Jan Kurs <kursjan@fit.cvut.cz>"
!

testLookup3
    |lo o match m|

    lo := JavaLookup instance.
    o := (Java classForName:('java.lang.Object')) new.
    match := lo 
                lookupMethodForSelector:#wait
                directedTo:o class
                for:o
                withArguments:nil
                from:self.
    self assert:match selector = #'wait()V'.

    "Created: / 30-08-2011 / 21:55:36 / Jan Kurs <kursjan@fit.cvut.cz>"
!

testLookup4
    |lo o match|

    lo := JavaLookup instance.
    o := (Java classForName:('java.lang.Object')) new.
    match := lo 
                lookupMethodForSelector:#wait:
                directedTo:o class
                for:o
                withArguments:nil
                from:self.
    self assert:match selector = #'wait(J)V'.

    "Created: / 30-08-2011 / 21:57:59 / Jan Kurs <kursjan@fit.cvut.cz>"
!

testLookupException
    |lo o match|

    lo := JavaLookup instance.
    o := (Java classForName:('java.lang.Object')) new.
    match := lo 
                lookupMethodForSelector:#foo:
                directedTo:o class
                for:o
                withArguments:nil
                from:self.
    self assert:match isNil.

    "Created: / 30-08-2011 / 22:10:50 / Jan Kurs <kursjan@fit.cvut.cz>"
! !

!LookupTests class methodsFor:'documentation'!

version_SVN
    ^ '$Id$'
! !
